
;// Crypt32.dll dataProtect include
;// Created / 26.04.2021 / by Marylin
;//******************************************

CRYPTPROTECT_DEFAULT_PROVIDER     dd  0xdf9d8cd0,0x11d11501,0xc0007a8c,0xeb97c24f

dwFORCE_KEY_PROTECTION_DISABLED     = 0x0
dwFORCE_KEY_PROTECTION_USER_SELECT  = 0x1
dwFORCE_KEY_PROTECTION_HIGH         = 0x2

;// CryptProtectData and CryptUnprotectData dwFlags
;//**************************************************
CRYPTPROTECT_UI_FORBIDDEN           = 0x01
CRYPTPROTECT_LOCAL_MACHINE          = 0x04
CRYPTPROTECT_CRED_SYNC              = 0x08
CRYPTPROTECT_AUDIT                  = 0x10
CRYPTPROTECT_NO_RECOVERY            = 0x20
CRYPTPROTECT_VERIFY_PROTECTION      = 0x40
CRYPTPROTECT_CRED_REGENERATE        = 0x80
CRYPTPROTECT_FIRST_RESERVED_FLAGVAL = 0x0FFFFFFF
CRYPTPROTECT_LAST_RESERVED_FLAGVAL  = 0xFFFFFFFF

;// CryptProtectMemory and CryptUnprotectMemory dwFlags
;//******************************************************
CRYPTPROTECTMEMORY_SAME_PROCESS     = 0x00
CRYPTPROTECTMEMORY_CROSS_PROCESS    = 0x01
CRYPTPROTECTMEMORY_SAME_LOGON       = 0x02
CRYPTPROTECTMEMORY_BLOCK_SIZE       = 0x10

CRYPTPROTECT_PROMPT_ON_UNPROTECT    = 0x01
CRYPTPROTECT_PROMPT_ON_PROTECT      = 0x02
CRYPTPROTECT_PROMPT_RESERVED        = 0x04
CRYPTPROTECT_PROMPT_STRONG          = 0x08
CRYPTPROTECT_PROMPT_REQUIRE_STRONG  = 0x10

;// CryptBinaryToString/CryptStringToBinary flags
;//******************************************************
CRYPT_STRING_BASE64HEADER        = 0x00        ;//   
CRYPT_STRING_BASE64              = 0x01        ;// Base64,  
CRYPT_STRING_BINARY              = 0x02        ;//   
CRYPT_STRING_BASE64REQUESTHEADER = 0x03        ;//   
CRYPT_STRING_HEX                 = 0x04        ;//  
CRYPT_STRING_HEXASCII            = 0x05        ;//    ASCII
CRYPT_STRING_BASE64_ANY          = 0x06        ;// 
CRYPT_STRING_ANY                 = 0x07        ;// 
CRYPT_STRING_HEX_ANY             = 0x08        ;// 
CRYPT_STRING_BASE64X509CRLHEADER = 0x09        ;// 
CRYPT_STRING_HEXADDR             = 0x0a        ;// ,   
CRYPT_STRING_HEXASCIIADDR        = 0x0b        ;// ,    ASCII  
CRYPT_STRING_HEXRAW              = 0x0c        ;//   .
CRYPT_STRING_BASE64URI           = 0x0d        ;// 
CRYPT_STRING_PERCENTESCAPE       = 0x08000000
CRYPT_STRING_HASHDATA            = 0x10000000
CRYPT_STRING_STRICT              = 0x20000000
CRYPT_STRING_NOCRLF              = 0x40000000
CRYPT_STRING_NOCR                = 0x80000000

;//     
;//----------------------------------------------
CALG_DES                = 0x00006601
CALG_3DES               = 0x00006603
CALG_AES                = 0x00006611
CALG_AES_128            = 0x0000660e
CALG_AES_192            = 0x0000660f
CALG_AES_256            = 0x00006610
CALG_RC2                = 0x00006602
CALG_RC4                = 0x00006801
CALG_RC5                = 0x0000660d

CALG_RSA_KEYX           = 0x0000a400
CALG_RSA_SIGN           = 0x00002400

CALG_HASH_REPLACE_OWF   = 0x0000800b
CALG_HMAC               = 0x00008009
CALG_MAC                = 0x00008005
CALG_MD2                = 0x00008001
CALG_MD4                = 0x00008002
CALG_MD5                = 0x00008003
CALG_SHA                = 0x00008004
CALG_SHA1               = 0x00008004
CALG_SHA256             = 0x0000800c
CALG_SHA384             = 0x0000800d
CALG_SHA512             = 0x0000800e
CALG_SSL3_SHAMD5        = 0x00008008
CALG_TLS1_PRF           = 0x0000800a


;//   ( = 4)
;//----------------------------------
CryptTable        dd  0x6603,calgDes,0x6610,calgAes
                  dd  0x6801,calgRc4,0x660d,calgRc5
calgDes           db  '3DES',0
calgAes           db  'AES.256',0
calgRc4           db  'RC4',0
calgRc5           db  'RC5',0

;//   ( = 13)
;//-----------------------------------
HashTable         dd  0x800b,calgOwf,0x8009,calgHma,0x8005,calgMac,0x8001,calgMd2
                  dd  0x8002,calgMd4,0x8003,calgMd5,0x8004,calgSha,0x8004,calgSha1
                  dd  0x800c,calgSha256,0x800d,calgSha384,0x800e,calgSha512,0x8008,calgSsl3
                  dd  0x800a,calgTls
calgOwf           db  'HASH_REPLACE_OWF',0
calgHma           db  'HMAC',0
calgMac           db  'MAC',0
calgMd2           db  'MD2',0
calgMd4           db  'MD4',0
calgMd5           db  'MD5',0
calgSha           db  'SHA',0
calgSha1          db  'SHA1',0
calgSha256        db  'SHA.256',0
calgSha384        db  'SHA.384',0
calgSha512        db  'SHA.512',0
calgSsl3          db  'SSL3.SHAMD5',0
calgTls           db  'TLS1.PRF',0
unk               db  'Unknown',0


struct CRYPTPROTECT_PROMPTSTRUCT
   cbSize          dd  sizeof.CRYPTPROTECT_PROMPTSTRUCT
   dwPromptFlags   dd  0  ;//
   hwndApp         dd  0  ;//
   szPrompt        dd  0  ;//
ends

struct CRYPT_BLOB
  dataSize         dd  0  ;//  
  pData            dd  0  ;//    
ends


struct MASTERKEY_HEADER
  dwVersion            dd  0         ;//    -
  dwReserved1          dq  0         ;// 
  szGuid               db  72 dup(0) ;// -  GUID'
  dwUnused             dq  0         ;// 
  dwPolicy             dd  0         ;//   
  dwUserKeySize        dd  0         ;//  - 
  dwLocalEncKeySize    dd  0         ;//    Backup
  dwLocalKeySize       dd  0         ;//   ,   CREDHIST
  dwDomainKeySize      dd  0         ;//    
  dwReserved2          db  16 dup(0) ;//  ????
;//
  Version              dd  0         ;//  
  pSalt                db  16 dup(0) ;//  ,   
  dwRounds             dd  0         ;//       PBKDF2
  HMACAlgId            dd  0         ;//    
  CryptAlgId           dd  0         ;//   
  pKey                 dd  0         ;//  -
ends

struct DPAPI_DATABLOB                ;// https://www.passcape.com/index.php?setLang=6
  dwVersion            dd  0         ;//  
  ProvGuid             db  16 dup(0) ;// Guid -
  MasterKeyVersion     dd  0         ;//  
  MasterKeyGuid        db  16 dup(0) ;// Guid 
  dwFlags              dd  0         ;// 
  dwDataDescLen        dd  0         ;//  (2) "DataDescr"  CryptProtectData()
  szDataDesc           db  ?         ;//   .. .
  algCrypt             dd  0         ;//   ( AES)
  cryptAlgLen          dd  0         ;//   ..  ( 256,  AES-256)
  dwSaltLen            dd  0         ;//   
  pSalt                db  ?         ;//   .. 
  dwHmacKeyLen         dd  0         ;//  "-" HMAC
  pHmac                db  ?         ;//   .. HMAC
  algHash              dd  0         ;//   ( SHA)
  hashAlgLen           dd  0         ;//   ..  ( 512,  SHA-512)
  dwHmac2KeyLen        dd  0         ;// .
  pHmac2               db  ?         ;//   ^^^
  dwDataLen            dd  0         ;//   
  pData                db  ?         ;//   ..
  dwSignLen            dd  0         ;//  
  pSign                db  ?         ;//   ..
ends



;// ************  ****************************************
if 0
BOOL CryptBinaryToStringA   ;//  Base64 ( )
   pbBinary       dd  0     ;//   
   cbBinary       dd  0     ;// -    pbBinary
   dwFlags        dd  0     ;//  CRYPT_STRING_***
   pszString      dd  0     ;//     (0 =  )
   pcchString     dd  0     ;//    

BOOL CryptStringToBinaryA   ;//  Base64 ( )
   pszString      dd  0     ;//   
   cchString      dd  0     ;//   (  )
   dwFlags        dd  0     ;//  CRYPT_STRING_***
   pbBinary       dd  0     ;//    
   pcbBinary      dd  0     ;//   (  -    )
   pdwSkip        dd  0     ;// 0
   pdwFlags       dd  0     ;// 0

;//  CryptProtectData        . 
;//           BLOB.
;// Message Authentication Code (MAC-)    
;//      ,      - . 
;//       ERROR_INVALID_DATA.

BOOL CryptUnprotectData(    ;// 0 = !
  pDataIn            dd  0  ;//   DATA_BLOB,     
  ppszDataDescr      dd  0  ;// 0       
  pOptionalEntropy   dd  0  ;// 0    DATA_BLOB,    . ()
  pvReserved         dd  0  ;// 0 
  pPromptStruct      dd  0  ;// 0     CRYPTPROTECT_PROMPTSTRUCT
  dwFlags            dd  0  ;// 0    
  pDataOut           dd  0  ;//   DATA_BLOB,      
);

end if








